echo off

Set /A errorID=0

SETLOCAL EnableDelayedExpansion

set function=%1
set type=%2

set return=0


if /i "%function%" == "OnItem" goto :OnItem
if /i "%function%" == "OnFix" goto :OnFix
if /i "%function%" == "OnChange" goto :OnChange


::========================================================
::parameters examples:
::OnItem file "C:\\temp\\test\\mylog.log"
::OnItem registry "HKCU\Software\Tweakeze\Test"
::OnItem registry "HKCU\Software\Tweakeze\Test" "MyValue" 
::OnItem registry "HKCU\Software\Tweakeze\Test" "MyValue" "this is a string"
:OnItem
if /i "%type%" == "file" (
	::return 0 to ignore this item in the UI
	set return=1
	goto :end
)

if /i "%type%" == "registry" (
	::return 0 to ignore this item in the UI
	set return=1
	goto :end
)
::========================================================

::========================================================
::parameters examples:
::OnItem file "C:\\temp\\test\\mylog.log"
::OnItem registry "HKCU\Software\Tweakeze\Test"
::OnItem registry "HKCU\Software\Tweakeze\Test" "MyValue" 
::OnItem registry "HKCU\Software\Tweakeze\Test" "MyValue" "this is a string"
:OnFix

if /i "%type%" == "registry" (
	::always allow to fix or return 0 to prevent fixing it
	set return=1
	goto :end
)

set filename=%3

if /i "%type%" == "file" (
	
	for %%i in (%filename%) do (
		set fext=%%~xi
	)
	echo !fext!
	
	::we only fix tmp files
	if "!fext!" == ".tmp" (
		set return=1
	)
	
	set fext=
)
set filename=
goto :end
::========================================================

::========================================================
::parameters example: (Only for File changes)
::OnChange file "C:\\temp\\test\\New Text Document.tmp" 1
::the last parameter is the Notification Change type
::Add 				= 1		==>The file was added to the directory.
::Removed 			= 2 	==>The file was removed from the directory. When a file is renamed to a different directory the client will receive this notification along with MODIFIED.
::Modified 			= 3		==> The file was modified. This can be a change to the data or attributes of the file. When a file is renamed to a different directory the client will receive this notification along with REMOVED.
::Renamed_Old_Name	= 4 	==>The file was renamed, and this is the old name. This notification is only sent when the rename operation does not change the directory the file resides in. The client will also receive a RENAMED_NEW_NAME notification. This notification will not be received if the file is renamed to a different directory.
::Renamed_New_Name	= 5 	==>The file was renamed, and this is the new name. This notification is only sent when the rename operation does not change the directory the file resides in. The client will also receive a RENAME_OLD_NAME notification. This notification will not be received if the file is renamed to a different directory.
:OnChange
set filename=%3
set changeType=%4

if /i "%type%" == "file" (
	For %%A in (%filename%) do (
		Set Folder=%%~dpA
	)
	::echo !Folder!
	::uncoment to create log file with changes
	::echo %filename%  %changeType% >> !Folder!mylog.txt
)
set filename=
set changeType=
goto :end
::========================================================

:end
set function=
set type=

rem echo %return%
exit %return%
